{% include "lkft-configs.yaml.jinja2" %}
{% include "lkft-oe-rootfs.yaml.jinja2" %}
{% include "tux-debian-rootfs.yaml.jinja2" %}
{% include "timeouts.yaml.jinja2" %}

version: 1
name: full kernel validation for the master branch.
description: Build and test linux kernel with every toolchain
jobs:
{%- if toolchain == "gcc-9" %}
- name: arc
  builds:
    - {target_arch: arc, toolchain: {{ toolchain }}, kconfig: allnoconfig}
    - {target_arch: arc, toolchain: {{ toolchain }}, kconfig: defconfig}
    - {target_arch: arc, toolchain: {{ toolchain }}, kconfig: tinyconfig}
    - {target_arch: arc, toolchain: {{ toolchain }}, kconfig: axs103_defconfig}
    - {target_arch: arc, toolchain: {{ toolchain }}, kconfig: vdk_hs38_smp_defconfig}
{%- endif %}
# arm
- name: armv5
  builds:
    - {target_arch: arm, toolchain: {{ toolchain }},  kconfig: [multi_v5_defconfig, CONFIG_KUNIT=y, CONFIG_KUNIT_ALL_TESTS=y]{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
  tests:
{% set device_name = "qemu-armv5" %}
{%- set rootfs = "" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["kunit", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: arm
  builds:
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: allnoconfig{% if toolchain.startswith('clang-') %},           make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: defconfig{% if toolchain.startswith('clang-') %},             make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: tinyconfig{% if toolchain.startswith('clang-') %},            make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: at91_dt_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: axm55xx_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: bcm2835_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: clps711x_defconfig{% if toolchain.startswith('clang-') %},    make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: davinci_all_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: exynos_defconfig{% if toolchain.startswith('clang-') %},      make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: footbridge_defconfig{% if toolchain.startswith('clang-') %},  make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: imx_v4_v5_defconfig{% if toolchain.startswith('clang-') %},   make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: imx_v6_v7_defconfig{% if toolchain.startswith('clang-') %},   make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: integrator_defconfig{% if toolchain.startswith('clang-') %},  make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: keystone_defconfig{% if toolchain.startswith('clang-') %},    make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: lpc32xx_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: multi_v5_defconfig{% if toolchain.startswith('clang-') %},    make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: mxs_defconfig{% if toolchain.startswith('clang-') %},         make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: nhk8815_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: omap1_defconfig{% if toolchain.startswith('clang-') %},       make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: omap2plus_defconfig{% if toolchain.startswith('clang-') %},   make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: orion5x_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: pxa910_defconfig{% if toolchain.startswith('clang-') %},      make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: s3c6400_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: s5pv210_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: sama5_defconfig{% if toolchain.startswith('clang-') %},       make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: shmobile_defconfig{% if toolchain.startswith('clang-') %},    make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: u8500_defconfig{% if toolchain.startswith('clang-') %},       make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm, toolchain: {{ toolchain }}, kconfig: vexpress_defconfig{% if toolchain.startswith('clang-') %},    make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
{%- if toolchain == "gcc-12" %}
- name: arm-lkftconfig-build-only
  builds:
    - build_name: {{ toolchain }}-lkftconfig-debug
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_DEBUG_ATOMIC_SLEEP=y, CONFIG_DEBUG_INFO=y, CONFIG_DEBUG_PREEMPT=y, CONFIG_DEBUG_VM=y ]
    - build_name: {{ toolchain }}-lkftconfig-debug-kmemleak
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_DEBUG_KMEMLEAK=y ]
    - build_name: {{ toolchain }}-lkftconfig-kasan
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_KASAN=y, CONFIG_FTRACE=n, CONFIG_KPROBES=n ]
    - build_name: {{ toolchain }}-lkftconfig-perf
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "modules", "perf"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_FTRACE_SYSCALLS=y ]
{%- endif %}
{%- if toolchain.startswith('clang-') %}
- name: arm-{{ toolchain }}-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/net/config, tools/testing/selftests/net/mptcp/config, tools/testing/selftests/net/hsr/config, tools/testing/selftests/net/forwarding/config, tools/testing/selftests/tc-testing/config ]
  tests:
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-net]
      sharding: 5
      timeouts: { "boot": *boot-timeout-arm, "kselftest-net": *kselftest-net-timeout }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-tc-testing]
      timeouts: { "boot": *boot-timeout-arm }
{%- endif %}
{# For now only builds with gcc and not clang... #}
{%- if toolchain.startswith('gcc-12') %}
- name: arm-lkftconfig-tests-no-kselftest-frag
  builds:
    - build_name: {{ toolchain }}-lkftconfig-no-kselftest-frag
      target_arch: arm
      toolchain: {{ toolchain }}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_KFENCE=n ]
  tests:
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-capabilities]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-clone3]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-core]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-cpu-hotplug]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-exec]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-fpu]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-futex]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-kcmp]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-membarrier]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-mincore]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-mqueue]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-openat2]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-rseq]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-rtc]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-sigaltstack]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-size]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-timers]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-tmpfs]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-tpm2]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-user_events]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-vDSO]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-watchdog]
      timeouts: { "boot": *boot-timeout-arm }
{%- endif %}
- name: arm-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/gpio/config, tools/testing/selftests/ipc/config, tools/testing/selftests/kcmp/config, tools/testing/selftests/memfd/config ]
  tests:
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-gpio]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-ipc]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-kcmp]
      timeouts: { "boot": *boot-timeout-arm }
    - device: qemu-armv7
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm
      tests: [kselftest-memfd]
      timeouts: { "boot": *boot-timeout-arm }
- name: arm-lkftconfig-tests
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_KFENCE=n ]
  tests:
{% set device_name = "qemu-armv7" %}
{%- set rootfs = "*rootfs-lkft-arm" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: arm-{{ toolchain }}-libgpiod
  builds:
    - build_name: {{ toolchain }}-lkftconfig-libgpiod
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_KFENCE=n, CONFIG_GPIOLIB=y, CONFIG_GPIO_CDEV=y, CONFIG_GPIO_MOCKUP=m ]
  tests:
{%- set tests = [["libgpiod", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: arm-{{ toolchain }}-kunit
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kunit
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_KFENCE=n, CONFIG_KASAN=y, CONFIG_KUNIT=y, CONFIG_KUNIT_ALL_TESTS=y ]
  tests:
{%- set tests = [["kunit", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: arm-{{ toolchain }}-rcutorture
  builds:
    - build_name: {{ toolchain }}-lkftconfig-rcutorture
      target_arch: arm
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM_TI_CPUFREQ=y, CONFIG_SERIAL_8250_OMAP=y, CONFIG_POSIX_MQUEUE=y, CONFIG_OF=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_AHCI_DWC=y, CONFIG_KFENCE=n, CONFIG_RCU_TORTURE_TEST=m ]
  tests:
{%- set tests = [["rcutorture", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
# arm64
- name: arm64
  builds:
    - {target_arch: arm64, toolchain: {{ toolchain }},   kconfig: allnoconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm64, toolchain: {{ toolchain }},   kconfig: defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: arm64, toolchain: {{ toolchain }},   kconfig: tinyconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
- name: arm64-defconfig-no-fvp
  builds:
    - {target_arch: arm64, toolchain: {{ toolchain }}, kconfig: [defconfig, CONFIG_KASAN=y, CONFIG_KUNIT=y, CONFIG_KUNIT_ALL_TESTS=y]{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
  tests:
{% set device_name = "qemu-arm64" %}
{%- set rootfs = "*rootfs-lkft-arm64" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["kunit", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: arm64-lkftconfig-build-only
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y ]
    - build_name: {{ toolchain }}-lkftconfig-kasan
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_KASAN=y ]
    - build_name: {{ toolchain }}-lkftconfig-perf
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "modules", "perf"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_FTRACE_SYSCALLS=y ]
{# For now only builds with clang not with gcc... #}
{%- if toolchain.startswith('clang-') %}
- name: arm64-{{ toolchain }}-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/net/config, tools/testing/selftests/net/mptcp/config, tools/testing/selftests/net/hsr/config, tools/testing/selftests/net/forwarding/config, tools/testing/selftests/tc-testing/config ]
  tests:
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-net]
      sharding: 5
      timeouts: { "boot": *boot-timeout-arm64, "kselftest-net": *kselftest-net-timeout }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-tc-testing]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-net]
      sharding: 5
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-net": *kselftest-net-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-tc-testing]
      timeouts: { "boot": *boot-timeout-fvp }
{%- endif %}
- name: arm64-lkftconfig-tests-no-kselftest-frag
  builds:
    - build_name: {{ toolchain }}-lkftconfig-no-kselftest-frag
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y ]
  tests:
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-arm64]
      timeouts: { "boot": *boot-timeout-arm64, "kselftest-arm64": *kselftest-arm64-timeout }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-breakpoints]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-capabilities]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-clone3]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-core]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-cpu-hotplug]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-exec]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-fpu]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-futex]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-kcmp]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-membarrier]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-mincore]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-mqueue]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-openat2]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-rseq]
      timeouts: { "boot": *boot-timeout-arm64, "kselftest-rseq": *kselftest-timeout }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-rtc]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-sigaltstack]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-size]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-timers]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-tmpfs]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-tpm2]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-user_events]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-vDSO]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-watchdog]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-arm64]
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-arm64": *kselftest-arm64-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-breakpoints]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-capabilities]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-clone3]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-core]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-cpu-hotplug]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-exec]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-fpu]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-futex]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-kcmp]
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-kcmp": *kselftest-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-membarrier]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-mincore]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-mqueue]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-openat2]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-rseq]
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-rseq": *kselftest-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-rtc]
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-rtc": *kselftest-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-sigaltstack]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-size]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-timers]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-tmpfs]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-tpm2]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-user_events]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-vDSO]
      timeouts: { "boot": *boot-timeout-fvp }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-watchdog]
      timeouts: { "boot": *boot-timeout-fvp }
- name: arm64-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["dtbs", "dtbs-legacy", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/gpio/config, tools/testing/selftests/ipc/config, tools/testing/selftests/kcmp/config, tools/testing/selftests/memfd/config ]
  tests:
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-gpio]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-ipc]
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: qemu-arm64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-memfd]
      timeouts: { "boot": *boot-timeout-arm64, "kselftest-memfd": *kselftest-memfd-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-gpio]
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-gpio": *kselftest-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-ipc]
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-ipc": *kselftest-timeout }
    - device: fvp-aemva
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-arm64
      tests: [kselftest-memfd]
      timeouts: { "boot": *boot-timeout-fvp, "kselftest-memfd": *kselftest-memfd-timeout }
- name: arm64-lkftconfig-boot-tests-only
  builds:
    - build_name: {{ toolchain }}-lkftconfig-devicetree
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_OF_UNITTEST=y ]
  tests:
    - device: qemu-arm64
      parameters: {SKIPFILE: "skipfile-lkft.yaml"}
      rootfs: *rootfs-lkft-arm64
      timeouts: { "boot": *boot-timeout-arm64 }
    - device: fvp-aemva
      parameters: {SKIPFILE: "skipfile-lkft.yaml"}
      rootfs: *rootfs-lkft-fvp
      timeouts: { "boot": *boot-timeout-fvp }
- name: arm64-lkftconfig-tests-no-fvp
  builds:
    - build_name: {{ toolchain }}-lkftconfig-debug
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_DEBUG_ATOMIC_SLEEP=y, CONFIG_DEBUG_INFO=y, CONFIG_DEBUG_PREEMPT=y, CONFIG_DEBUG_VM=y ]
    - build_name: {{ toolchain }}-lkftconfig-debug-kmemleak
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_DEBUG_KMEMLEAK=y ]
  tests:
{% set device_name = "qemu-arm64" %}
{%- set rootfs = "*rootfs-lkft-arm64" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: arm64-lkftconfig-tests-compat
  builds:
    - build_name: {{ toolchain }}-lkftconfig-compat
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y ]
  tests:
{% set device_name = "qemu-arm64" %}
{%- set rootfs = "*rootfs-lkft-arm" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: arm64-lkftconfig-tests
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y ]
    - build_name: {{ toolchain }}-lkftconfig-64k_page_size
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_ARM64_64K_PAGES=y ]
    - build_name: {{ toolchain }}-lkftconfig-armv8_features
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_ARM64_RAS_EXTN=y, CONFIG_ARM64_PMEM=y, CONFIG_ARM64_CNP=y, CONFIG_ARM64_SW_TTBR0_PAN=y ]
  tests:
{% set device_name = "qemu-arm64" %}
{%- set rootfs = "*rootfs-lkft-arm64" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
{%- set device_name = "fvp-aemva" %}
{%- set rootfs = "*rootfs-lkft-fvp" %}
{%- set boot_timeout = boot_timeout|default(60) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: arm64-{{ toolchain }}-libgpiod
  builds:
    - build_name: {{ toolchain }}-lkftconfig-libgpiod
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_GPIOLIB=y, CONFIG_GPIO_CDEV=y, CONFIG_GPIO_MOCKUP=m ]
  tests:
{% set device_name = "qemu-arm64" %}
{%- set rootfs = "*rootfs-lkft-arm64" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["libgpiod", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- set device_name = "fvp-aemva" %}
{%- set rootfs = "*rootfs-lkft-fvp" %}
{%- set boot_timeout = boot_timeout|default(60) %}
{%- set tests = [["libgpiod", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: arm64-{{ toolchain }}-kunit
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kunit
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_KASAN=y, CONFIG_KUNIT=y, CONFIG_KUNIT_ALL_TESTS=y ]
  tests:
{% set device_name = "qemu-arm64" %}
{%- set rootfs = "*rootfs-lkft-arm64" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["kunit", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- set device_name = "fvp-aemva" %}
{%- set rootfs = "*rootfs-lkft-fvp" %}
{%- set boot_timeout = boot_timeout|default(60) %}
{%- set tests = [["kunit", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: arm64-{{ toolchain }}-rcutorture
  builds:
    - build_name: {{ toolchain }}-lkftconfig-rcutorture
      target_arch: arm64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_ARM64_MODULE_PLTS=y, CONFIG_SYN_COOKIES=y, CONFIG_SCHEDSTATS=y, CONFIG_RCU_TORTURE_TEST=m ]
  tests:
{% set device_name = "qemu-arm64" %}
{%- set rootfs = "*rootfs-lkft-arm64" %}
{%- set boot_timeout = boot_timeout|default(30) %}
{%- set tests = [["rcutorture", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{% set device_name = "fvp-aemva" %}
{%- set rootfs = "*rootfs-lkft-fvp" %}
{%- set boot_timeout = boot_timeout|default(60) %}
{%- set tests = [["rcutorture", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
# i386
- name: i386
  builds:
    - {target_arch: i386, toolchain: {{ toolchain }},  kconfig: allnoconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: i386, toolchain: {{ toolchain }},  kconfig: i386_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: i386, toolchain: {{ toolchain }},  kconfig: tinyconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
- name: i386-lkftconfig-build-only
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y ]
    - build_name: {{ toolchain }}-lkftconfig-debug
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_DEBUG_ATOMIC_SLEEP=y, CONFIG_DEBUG_INFO=y, CONFIG_DEBUG_PREEMPT=y, CONFIG_DEBUG_VM=y ]
    - build_name: {{ toolchain }}-lkftconfig-debug-kmemleak
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_DEBUG_KMEMLEAK=y ]
    - build_name: {{ toolchain }}-lkftconfig-perf
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "headers", "kernel", "modules", "perf"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_FTRACE_SYSCALLS=y ]
{# builds only working for clang for now... #}
{%- if toolchain.startswith('clang-') %}
- name: i386-{{ toolchain }}-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "cpupower", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/net/config, tools/testing/selftests/net/mptcp/config, tools/testing/selftests/net/hsr/config, tools/testing/selftests/net/forwarding/config, tools/testing/selftests/tc-testing/config ]
  tests:
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-net]
      sharding: 5
      timeouts: { "boot": *boot-timeout-i386, "kselftest-net": *kselftest-net-timeout }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-tc-testing]
      timeouts: { "boot": *boot-timeout-i386 }
{%- endif %}
- name: i386-lkftconfig-tests-no-kselftest-frag
  builds:
    - build_name: {{ toolchain }}-lkftconfig-no-kselftest-frag
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "cpupower", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y ]
  tests:
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-capabilities]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-clone3]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-core]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-cpu-hotplug]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-exec]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-fpu]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-futex]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-intel_pstate]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-kcmp]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-membarrier]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-mincore]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-mqueue]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-openat2]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-ptrace]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-rseq]
      timeouts: { "boot": *boot-timeout-i386, "kselftest-rseq": *kselftest-timeout }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-rtc]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-sigaltstack]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-size]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-timers]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-tmpfs]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-tpm2]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-user_events]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-vDSO]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-watchdog]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-x86]
      timeouts: { "boot": *boot-timeout-i386 }
- name: i386-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "cpupower", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/gpio/config, tools/testing/selftests/ipc/config, tools/testing/selftests/kcmp/config, tools/testing/selftests/memfd/config ]
  tests:
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-gpio]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-ipc]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-kexec]
      timeouts: { "boot": *boot-timeout-i386 }
    - device: qemu-i386
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-i386
      tests: [kselftest-memfd]
      timeouts: { "boot": *boot-timeout-i386 }
- name: i386-lkftconfig-tests
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y ]
  tests:
{% set device_name = "qemu-i386" %}
{%- set rootfs = "*rootfs-lkft-i386" %}
{%- set boot_timeout = boot_timeout|default(15) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: i386-{{ toolchain }}-libgpiod
  builds:
    - build_name: {{ toolchain }}-lkftconfig-libgpiod
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_GPIOLIB=y, CONFIG_GPIO_CDEV=y, CONFIG_GPIO_MOCKUP=m ]
  tests:
{% set tests = [["libgpiod", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: i386-{{ toolchain }}-kunit
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kunit
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_KASAN=y, CONFIG_KUNIT=y, CONFIG_KUNIT_ALL_TESTS=y ]
  tests:
{% set tests = [["kunit", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: i386-{{ toolchain }}-rcutorture
  builds:
    - build_name: {{ toolchain }}-lkftconfig-rcutorture
      target_arch: i386
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_RCU_TORTURE_TEST=m ]
  tests:
{% set tests = [["rcutorture", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
# mips
- name: mips
  builds:
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: allnoconfig{% if toolchain.startswith('clang-') %},       make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: defconfig{% if toolchain.startswith('clang-') %},         make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: tinyconfig{% if toolchain.startswith('clang-') %},        make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: ar7_defconfig{% if toolchain.startswith('clang-') %},     make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: ath79_defconfig{% if toolchain.startswith('clang-') %},   make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: bcm47xx_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: bcm63xx_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: cavium_octeon_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: malta_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: mips, toolchain: {{ toolchain }}, kconfig: rt305x_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
{%- if toolchain == "gcc-8" or toolchain == "gcc-11" %}
- name: parisc
  builds:
    - {target_arch: parisc, toolchain: {{ toolchain }}, kconfig: allnoconfig}
    - {target_arch: parisc, toolchain: {{ toolchain }}, kconfig: defconfig}
    - {target_arch: parisc, toolchain: {{ toolchain }}, kconfig: tinyconfig}
{%- endif %}
- name: ppc
  builds:
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: allnoconfig{% if toolchain.startswith('clang-') %},       make_variables: {LLVM: 1, LLVM_IAS: 0}{% endif %}}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: defconfig{% if toolchain.startswith('clang-') %},         make_variables: {LLVM: 1, LLVM_IAS: 0, LD: powerpc64le-linux-gnu-ld}{% endif %}}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: tinyconfig{% if toolchain.startswith('clang-') %},        make_variables: {LLVM: 1, LLVM_IAS: 0}{% endif %}}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: ppc64e_defconfig{% if toolchain.startswith('clang-') %},  make_variables: {LLVM: 1, LLVM_IAS: 0, LD: powerpc64le-linux-gnu-ld}{% endif %}}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: cell_defconfig{% if toolchain.startswith('clang-') %},    make_variables: {LLVM_IAS: 0}{% endif %}}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: maple_defconfig{% if toolchain.startswith('clang-') %},   make_variables: {LLVM: 1, LLVM_IAS: 0, LD: powerpc64le-linux-gnu-ld}{% endif %}}
{# Reported upstream and not fixed OR? only works for gcc #}
{%- if toolchain.startswith('gcc-') %}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: ppc6xx_defconfig}
{%- endif %}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: mpc83xx_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 0}{% endif %}}
    - {target_arch: powerpc, toolchain: {{ toolchain }}, kconfig: tqm8xx_defconfig{% if toolchain.startswith('clang-') %},  make_variables: {LLVM: 1, LLVM_IAS: 0}{% endif %}}
- name: riscv
  builds:
    - {target_arch: riscv, toolchain: {{ toolchain }},      kconfig: allnoconfig{% if toolchain.startswith('clang-') %},  make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: riscv, toolchain: {{ toolchain }},      kconfig: defconfig{% if toolchain.startswith('clang-') %},    make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: riscv, toolchain: {{ toolchain }},      kconfig: tinyconfig{% if toolchain.startswith('clang-') %},   make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
- name: riscv-lkftconfig-tests
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: riscv
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_SYN_COOKIES=y ]
  tests:
{% set device_name = "qemu-riscv64" %}
{%- set rootfs = "" %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: riscv32-clang
  builds:
    - {target_arch: riscv, toolchain: {{ toolchain }},      kconfig: [allnoconfig, rv32_defconfig]{% if toolchain.startswith('clang-') %},  make_variables: {LLVM: 1}{% endif %}}
    - {target_arch: riscv, toolchain: {{ toolchain }},      kconfig: [defconfig, rv32_defconfig]{% if toolchain.startswith('clang-') %},    make_variables: {LLVM: 1}{% endif %}}
    - {target_arch: riscv, toolchain: {{ toolchain }},      kconfig: [tinyconfig, rv32_defconfig]{% if toolchain.startswith('clang-') %},   make_variables: {LLVM: 1}{% endif %}}
- name: riscv32-lkftconfig-tests
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: riscv
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
{%- endif %}
      kconfig: [ rv32_defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_SYN_COOKIES=y ]
  tests:
{% set device_name = "qemu-riscv32" %}
{%- set rootfs = "" %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: s390
  builds:
    - {target_arch: s390, toolchain: {{ toolchain }},  kconfig: allnoconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM_IAS: 0}{% endif %}}
{%- if toolchain == "gcc-8" %}
    - {target_arch: s390, toolchain: {{ toolchain }},  kconfig: [defconfig, CONFIG_DEBUG_INFO_BTF=n]}
{% else %}
    - {target_arch: s390, toolchain: {{ toolchain }},  kconfig: defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM_IAS: 0}{% endif %}}
{%- endif %}
    - {target_arch: s390, toolchain: {{ toolchain }},  kconfig: tinyconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM_IAS: 0}{% endif %}}
{%- if toolchain == "gcc-8" or toolchain == "gcc-11" %}
- name: sh
  builds:
    - {target_arch: sh, toolchain: {{ toolchain }}, kconfig: allnoconfig}
    - {target_arch: sh, toolchain: {{ toolchain }}, kconfig: defconfig}
    - {target_arch: sh, toolchain: {{ toolchain }}, kconfig: tinyconfig}
    - {target_arch: sh, toolchain: {{ toolchain }}, kconfig: dreamcast_defconfig}
    - {target_arch: sh, toolchain: {{ toolchain }}, kconfig: microdev_defconfig}
    - {target_arch: sh, toolchain: {{ toolchain }}, kconfig: shx3_defconfig}
{%- endif %}
{%- if toolchain != "gcc-12" %}
- name: sparc
  builds:
    - {target_arch: sparc, toolchain: {{ toolchain }}, kconfig: allnoconfig}
    - {target_arch: sparc, toolchain: {{ toolchain }}, kconfig: defconfig}
    - {target_arch: sparc, toolchain: {{ toolchain }}, kconfig: tinyconfig}
{%- endif %}
# x86_64
- name: x86_64
  builds:
    - {target_arch: x86_64, toolchain: {{ toolchain }}, kconfig: allnoconfig{% if toolchain.startswith('clang-') %},      make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: x86_64, toolchain: {{ toolchain }}, kconfig: tinyconfig{% if toolchain.startswith('clang-') %},       make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
    - {target_arch: x86_64, toolchain: {{ toolchain }}, kconfig: x86_64_defconfig{% if toolchain.startswith('clang-') %}, make_variables: {LLVM: 1, LLVM_IAS: 1}{% endif %}}
- name: x86-lkftconfig-build-only
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y ]
    - build_name: {{ toolchain }}-lkftconfig-kcsan
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_KCSAN=y ]
    - build_name: {{ toolchain }}kftconfig-debug
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_DEBUG_ATOMIC_SLEEP=y, CONFIG_DEBUG_INFO=y, CONFIG_DEBUG_PREEMPT=y, CONFIG_DEBUG_VM=y ]
    - build_name: {{ toolchain }}-lkftconfig-kasan
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_KASAN=y ]
    - build_name: {{ toolchain }}-lkftconfig-perf
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "headers", "kernel", "modules", "perf"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_FTRACE_SYSCALLS=y ]
{# only builds with clang for now... #}
{%- if toolchain.startswith('clang-') %}
- name: x86-{{ toolchain }}-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "cpupower", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/net/config, tools/testing/selftests/net/mptcp/config, tools/testing/selftests/net/hsr/config, tools/testing/selftests/net/forwarding/config, tools/testing/selftests/tc-testing/config ]
  tests:
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-net]
      sharding: 5
      timeouts: { "boot": *boot-timeout-x86_64, "kselftest-net": *kselftest-net-timeout }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-tc-testing]
      timeouts: { "boot": *boot-timeout-x86_64 }
{%- endif %}
- name: x86-lkftconfig-tests-no-kselftest-frag
  builds:
    - build_name: {{ toolchain }}-lkftconfig-no-kselftest-frag
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "cpupower", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y ]
  tests:
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-breakpoints]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-capabilities]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-clone3]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-core]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-cpu-hotplug]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-exec]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-fpu]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-futex]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-intel_pstate]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-kcmp]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-membarrier]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-mincore]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-mqueue]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-openat2]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-ptrace]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-rseq]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-rtc]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-sigaltstack]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-size]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-timers]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-tmpfs]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-tpm2]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-user_events]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-vDSO]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-watchdog]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-x86]
      timeouts: { "boot": *boot-timeout-x86_64 }
- name: x86-lkftconfig-kselftest
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kselftest
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      targets: ["debugkernel", "cpupower", "headers", "kernel", "kselftest", "modules"]
      kconfig: [ defconfig, *frag-lkft-systemd, tools/testing/selftests/gpio/config, tools/testing/selftests/ipc/config, tools/testing/selftests/kcmp/config, tools/testing/selftests/memfd/config ]
  tests:
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-gpio]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-ipc]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-kexec]
      timeouts: { "boot": *boot-timeout-x86_64 }
    - device: qemu-x86_64
      boot_args: rw
      parameters: {SKIPFILE: "skipfile-lkft.yaml", KSELFTEST: "$BUILD/kselftest.tar.xz"}
      rootfs: *rootfs-debian-testing-x86_64
      tests: [kselftest-memfd]
      timeouts: { "boot": *boot-timeout-x86_64 }
- name: x86-lkftconfig-tests-compat
  builds:
    - build_name: {{ toolchain }}-lkftconfig-compat
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y ]
  tests:
{% set device_name = "qemu-x86_64" %}
{%- set rootfs = "*rootfs-lkft-i386" %}
{%- set boot_timeout = boot_timeout|default(15) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: x86-lkftconfig-tests
  builds:
    - build_name: {{ toolchain }}-lkftconfig
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y ]
    - build_name: {{ toolchain }}-lkftconfig-debug-kmemleak
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_DEBUG_KMEMLEAK=y ]
  tests:
{% set device_name = "qemu-x86_64" %}
{%- set rootfs = "*rootfs-lkft-x86_64" %}
{%- set boot_timeout = boot_timeout|default(15) %}
{%- set tests = [["libhugetlbfs", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
{%- include "ltp-tests.yaml.jinja2" %}
- name: x86-{{ toolchain }}-libgpiod
  builds:
    - build_name: {{ toolchain }}-lkftconfig-libgpiod
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_GPIOLIB=y, CONFIG_GPIO_CDEV=y, CONFIG_GPIO_MOCKUP=m ]
  tests:
{% set tests = [["libgpiod", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: x86-{{ toolchain }}-kunit
  builds:
    - build_name: {{ toolchain }}-lkftconfig-kunit
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_KASAN=y, CONFIG_KUNIT=y, CONFIG_KUNIT_ALL_TESTS=y ]
  tests:
{% set tests = [["kunit", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
- name: x86-{{ toolchain }}-rcutorture
  builds:
    - build_name: {{ toolchain }}-lkftconfig-rcutorture
      target_arch: x86_64
      toolchain: {{ toolchain }}
{%- if toolchain.startswith('clang-') %}
      make_variables:
        LLVM: 1
        LLVM_IAS: 1
{%- endif %}
      kconfig: [ defconfig, *frag-lkft-base, *frag-lkft-crypto, *frag-lkft-distro, *frag-lkft-systemd, *frag-lkft-virtio, CONFIG_IGB=y, CONFIG_UNWINDER_FRAME_POINTER=y, CONFIG_SYN_COOKIES=y, CONFIG_RCU_TORTURE_TEST=m ]
  tests:
{% set tests = [["rcutorture", -1, -1]] %}
{%- include "tests.yaml.jinja2" %}
